use default namespace internal;
use namespace ESC;

ESC function parseDigest(filename) {
    try {
        return parseJSON(ESC::readFile(filename), filename);
    }
    catch (e) {
        throw new SyntaxError(filename + ": " + e.message);
    }
}

// This is _such_ a gross hack.  esc.sh needs to create esc-mtimes.txt
// which is an array of records with filename and mtime fields, where
// the mtime field is a numeric value representing the modification
// time relative to some arbitrary epoch.  Extra points for making
// that epoch the same as the ES epoch, but that's not required --
// just taking the mtime of the oldest file as the epoch is fine.

var mtimes = null;

function mtime(filename) {
    if (mtimes == null)
        mtimes = parseJSON(ESC::readFile("esc-mtimes.txt"));
    for ( let i=0 ; i < mtimes.length ; i++ )
        if (mtimes[i].filename == filename)
            return mtimes[i].mtime;
    throw new Error("mtime: Unknown file: " + filename);
}


print(parseDigest("../src/esc-env.es.digest"));
